/*
 * Copyright 1998-2005 VIA Technologies, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * VIA, AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#ifndef VIA_SHA_H
#define VIA_SHA_H

#ifdef __cplusplus
extern "C" {
#endif

#include "via_ace.h"

extern int asm_phe_available();
extern int asm_sha1_op3(void *src, void*dst, int nbytes);
extern int asm_sha256_op3(void *src, void*dst, int nbytes);
extern int asm_partial_sha1_op3(void *src, void*dst, int nblocks);
extern int asm_partial_sha256_op3(void *src, void*dst, int nblocks);
extern unsigned int bswap_32(unsigned int x);
extern int asm_is_nano();

struct phe_sha_context
{
	uint_64 length;
	unsigned int hash[32];	//must be 128 bytes?
};

#ifdef __cplusplus
}
#endif

#endif